﻿<?xml version="1.0" encoding="utf-8"?>
<Application>
	<DisplayInfo Title="Autodesk MotionBuilder" Publisher="Autodesk" Version="" ReleaseDate="">
		<UserCategories>
			<Category>Pre-Approved</Category>
		</UserCategories>
		<SoftwareCategories>
			<Category>Pre-Approved</Category>
			<Category>LABS Baseline</Category>
		</SoftwareCategories>
	</DisplayInfo>
	<DeploymentType Title="" Architecture="x64" Technology="Script" DetectionMethod="Script" ContentLocation="\\server01\sources$\Autodesk\MotionBuilder\archive\{SoftwareVersion}\win_{Architecture}\">
		<UninstallCommand>"Deploy-Application.exe" UNINSTALL</UninstallCommand>
		<InstallCommand>"Deploy-Application.exe" INSTALL</InstallCommand>
		<DetectionScript RunAs32Bit="False" Language="PowerShell">
			<TEXT>{DetectionStatement}
$Architecture = '{Architecture}'
$DetectionRegPath = '{DetectionRegPath}'
$RegKeyList = Get-ChildItem -Path $DetectionRegPath | Where-Object {($_.GetValue('DisplayName') -eq $DisplayName) -and !($_.GetValue('SystemComponent'))}

if($RegKeyList) {
	$RegKey = $RegKeyList | Where-Object {[version]$_.GetValue('DisplayVersion') -ge [version]$DisplayVersion}
	if($RegKey) {
		return $true
	}
}
			</TEXT>
		</DetectionScript>
		<Custom>
			<DetectionScriptLogic TargetItemPath="\\server01\sources$\Autodesk\MotionBuilder\archive\{SoftwareVersion}\win_{Architecture}\Files\*.zip" >
				<SCRIPT>
$RootPath = $args[0]
$appDT = $args[1]
$appSoftwareVersion = $args[2]
$TargetItemPath = $args[3]

$sourceFile = Get-Item -Path '{DetectionScriptFilePath}'

$null = [Reflection.Assembly]::LoadWithPartialName('System.IO.Compression.FileSystem')
$zip = [IO.Compression.ZipFile]::OpenRead($sourceFile.FullName)
$AppName = 'MotionBuilder'
$ReferenceFileArchivedPath = "Img/x64/$AppName/$AppName.msi"
$ReferenceFileArchivedItem = $zip.Entries | Where-Object {$_.FullName -like "$ReferenceFileArchivedPath"}

$TempDirPath = "$env:TEMP\$($sourceFile.BaseName)_TEMP"
$TempDir = New-Item -Path $TempDirPath -ItemType Directory -Force

$null = [System.IO.Compression.ZipFileExtensions]::ExtractToFile($ReferenceFileArchivedItem, "$($TempDir.FullName)\$($ReferenceFileArchivedItem.Name)", $true)

$ReferenceFile = Get-Item -Path "$TempDirPath\$($ReferenceFileArchivedItem.Name)"


## Get MSI Properties  

# Read property from MSI database
$WindowsInstaller = New-Object -ComObject WindowsInstaller.Installer
$MSIDatabase = $WindowsInstaller.GetType().InvokeMember("OpenDatabase", "InvokeMethod", $null, $WindowsInstaller, @($ReferenceFile.FullName, 0))

$Property = 'Manufacturer'
$Query = "SELECT Value FROM Property WHERE Property = '$($Property)'"
$View = $MSIDatabase.GetType().InvokeMember("OpenView", "InvokeMethod", $null, $MSIDatabase, ($Query))
$View.GetType().InvokeMember("Execute", "InvokeMethod", $null, $View, $null)
$Record = $View.GetType().InvokeMember("Fetch", "InvokeMethod", $null, $View, $null)
# Manufacturer
$Manufacturer = ($Record.GetType().InvokeMember("StringData", "GetProperty", $null, $Record, 1)).Trim()

$Property = 'ProductName'
$Query = "SELECT Value FROM Property WHERE Property = '$($Property)'"
$View = $MSIDatabase.GetType().InvokeMember("OpenView", "InvokeMethod", $null, $MSIDatabase, ($Query))
$View.GetType().InvokeMember("Execute", "InvokeMethod", $null, $View, $null)
$Record = $View.GetType().InvokeMember("Fetch", "InvokeMethod", $null, $View, $null)
# ProductName
$ProductName = ($Record.GetType().InvokeMember("StringData", "GetProperty", $null, $Record, 1)).Trim()

$Property = 'ProductVersion'
$Query = "SELECT Value FROM Property WHERE Property = '$($Property)'"
$View = $MSIDatabase.GetType().InvokeMember("OpenView", "InvokeMethod", $null, $MSIDatabase, ($Query))
$View.GetType().InvokeMember("Execute", "InvokeMethod", $null, $View, $null)
$Record = $View.GetType().InvokeMember("Fetch", "InvokeMethod", $null, $View, $null)
# ProductVersion
$ProductVersion = ($Record.GetType().InvokeMember("StringData", "GetProperty", $null, $Record, 1)).Trim()

# Commit database and close view
$MSIDatabase.GetType().InvokeMember("Commit", "InvokeMethod", $null, $MSIDatabase, $null)
$View.GetType().InvokeMember("Close", "InvokeMethod", $null, $View, $null)           
$MSIDatabase = $null
$View = $null
$null = [System.Runtime.Interopservices.Marshal]::ReleaseComObject($WindowsInstaller)

$DetectionStatement = @"
`$DisplayName = '$ProductName'.Trim()
`$DisplayVersion = '$ProductVersion'.Trim()
"@

$DetectionStatement

$null = Remove-Item -Path $TempDirPath -Recurse -Force
				</SCRIPT>
			</DetectionScriptLogic>
		</Custom>
	</DeploymentType>
</Application>